//banl balance sheet shock similar to Iacoveille 2015 and Khan Reza 2016
//shock will attack the balanc sheet of the bank by househild and government default
// all variables are normalaized to X/Y except l_i , i=P,I,R and lambda_i=Y*lambda_i
//with adjustment cost in the form of  (psi/2)(h-h(-1))^2/h_bar 
//related steady state file is Steady-state_RUN_Dynamic_1
//This version is with housing  producer
// there are lots of adjestment cost for everything
// this version is for comparing to Iacoviello 2015 with the same shock on impatient household
// %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

var 
//Lagrangians,*******1-6
lambda_P,lambda_I,lambda_R,lambda_B,lambda_m,lambda_phi,

//consumption,*****7-10
c_P,c_I,c_R,c_B,

//housing,******11-14
 h_P, h_I, h_R ,p_R,

//capital  deposit,*****15-18
k,d,r,r_k,

//Mortgage,****19-20
M,r_b,

//bank,****21
a,

//firm,******22-28
w_P,w_I,w_R,l_P,l_I,l_R,Y_f,

//Governemt,29-35
C,T,tr_P,tr_I,tr_R,g ,b_g,

//just for check ,36-37
h,tr,
//38-42
i_k,Y,i_h,p_h,p_k,
//shock 43-46 (Tranfer of Bank),46(government spending shock)
TB_I,TB_g,TB_T,GS,
//help on timing 47
TB_T_1,
//data 48-57
data_Y,data_C ,data_Ik,data_Ih ,data_a ,data_M ,data_b_g ,data_p_h ,data_loss,spread_rb_r;

 //predetermined_variables N ; 
// %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  varexo epsilon_TB_I,epsilon_TB_g,epsilon_GS ;


// %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

load just_for_check_0_Dyna.mat;
parameters 
  //beta
beta_P,beta_I,beta_B,
 // housing   labor   capital
varphi_h,varphi_l,iota,delta_h,delta_k,
 // taxs
tau_c,tau_w,tau_d,tau_k,tau_wr ,tau_p,tau_l
//  I
I_m,I_r,
 // collateral constraint,
rho_m,theta,
 // bank
phi,
 // firm,
iota_P,iota_I,iota_R,alpha_Y,A,
 // Government,
vartheta_P,vartheta_I,vartheta_R,rho_g,Expenditure_G,
//adjusment cost
psi_hh,psi_a,psi_kp,psi_h,a_bar,h_P_bar,h_I_bar,h_R_bar,i_k_bar,i_h_bar,p_k_bar,p_h_bar,
psi_k,psi_dh,psi_db,psi_m,psi_g,b_g_bar,d_bar,k_bar,M_bar,Y_bar,rho_b, C_bar,
//shock
rho_TB,rho_GS,str_TB_I;



// define the parameters
 //discount factors

beta_P=0.9925 ; %0.9916
beta_I=0.94 ; %0.9852
beta_B= 0.945; %0.957
 %%%level for housing and labor in utility
varphi_h=0.272; %0.2162
varphi_l=8.0117;%%%0.56 ;
 %%%Inverse labor suplly elasticity
iota=1 ;
 %%%depreciation rate
delta_h=0.0096 ;
delta_k=0.0162 ;%
 %%%Taxes
tau_c=0.05 ;
tau_w=0.32; %%%0.3
tau_wr=0.22 ; %%%0.2 

tau_p=0.014/4; %% 
tau_d=0.15 ;
tau_k=0.4 ; %0.4
tau_l=0;%

 %%%Imputed rents
I_r=0 ; %% 
 %%%Mortgage interest deduction
I_m= 1 ;  %%
 %%%Persistence in borrowing constraint
rho_m=0.70;
 %%%loan to value ratio
theta=0.90 ;
 %%%leverage ratio
phi=0.90; %%
 %%%Labor share in production
iota_P=0.135 ; 
iota_I=0.67 ; 
iota_R= 0.195; 
 %%%capital share in production
alpha_Y=0.2047 ;%0.2047
A= 1.805;
 %%%Transfer share
vartheta_P=0.040 ; 
vartheta_I=0.036 ; 
vartheta_R= 0.030; 
 %%% response of transfers to gov. debt
rho_g=0.003; %%%;
 %%%propertion of the gov, expenditure over output
Expenditure_G=0.25 ;
//shock
rho_TB=0.969199134850878; %0.9;
rho_GS=0.9;
str_TB_I = 0.00132513108400193; 

rho_b  =0.24 ; // if rho_b=0 we return to the baisc model without change in banking
//adjustment cost
psi_hh=0; %% adjestment cost households 0
psi_a=0.47+0.07;  %% adjestment cost bank 0.25
psi_kp=0;   %% adjestment cost capital producer 0
psi_h=2.48;    %% adjestment cost house producer 2.48
psi_k=1.73 ;   %% adjestment cost capital household 1.73
psi_dh=0.10 ;   %% adjestment cost capital deposit household 0.10
psi_db=0.14 ;   %% adjestment cost capital deposit bank 0.14
psi_m=0.37 ;   %% adjestment cost capital mortgage impatient 0.30
psi_g=10;
b_g_bar=b_g_0;
d_bar=d_0;
k_bar=k_0;
M_bar=M_0;
a_bar=a_0;
h_P_bar=h_P_0;
h_I_bar=h_I_0;
h_R_bar=h_R_0;
i_k_bar=i_k_0;
i_h_bar=i_h_0;
p_k_bar=p_k_0;
p_h_bar=p_h_0;
Y_bar=Y_0;
C_bar=C_0;

//*********************************************

model;


//lagrangians****************1,2,3,4
   (1+tau_c) * lambda_P= 1/ c_P ;
   (1+tau_c) * lambda_I= 1/ c_I ;
   (1+tau_c) * lambda_R= 1/ c_R ;
   (1+tau_c) * lambda_B= 1/ c_B ;

//budget constraints*****************************
   //Patient Household***5
   (1+tau_c)*c_P+ (h_P-(1-delta_h)* h_P(-1))*p_h+ (h_R-(1-delta_h)* h_R(-1))*p_h+ (k-(1-delta_k)*k(-1))*p_k+ d= 
 w_P *l_P+ p_R* h_R(-1)+ (1+r)*d(-1)+ r_k* k(-1)+ tr_P  - tau_w*(w_P *l_P+(p_R-delta_h)*( h_R(-1)+ I_r*  h_P(-1)) 
- tau_p *p_h *( h_P(-1)+ h_R(-1)))-tau_d* r* d(-1)-tau_k*(r_k-delta_k)*k(-1)- tau_p *p_h *( h_P(-1)+ h_R(-1))-tau_l *p_h *( h_P+ h_R)
- (psi_hh/2)*p_h*(h_P-h_P(-1))^2/h_P_bar - (psi_hh/2)*p_h*(h_R-h_R(-1))^2/h_R_bar
- (psi_k/2)*p_k*(k-k(-1))^2/k_bar- (psi_dh/2)* (d-d(-1))^2/d_bar;

   //ImPatient Household***6
   (1+tau_c)*c_I + (h_I -(1-delta_h)* h_I(-1))*p_h+(1+r_b)*M(-1)- TB_I * Y_bar= 
w_I* l_I + M + tr_I - tau_w*(w_I *l_I -I_m *r_b*M(-1)+ I_r*(p_R -delta_h)*  h_I(-1)- tau_p *p_h *  h_I(-1))
- tau_p *p_h *  h_I(-1)- tau_l * p_h *   h_I - (psi_hh/2)*p_h*(h_I-h_I(-1))^2/h_I_bar 
- (psi_m/2)* (M-M(-1))^2/M_bar  ; // for household shock + TB should be added to the RHS

   //Renter Household***7
   (1+tau_c)*c_R +p_R*   h_R(-1)= (1-tau_wr)*w_R * l_R +tr_R ;

   //Bank***8,9
   a =b_g +M ;
   // a=M;
   (1+tau_c)* c_B +(1+r)*d(-1)+ a = d +(1+r_b)*a(-1)- TB_T * Y_bar - (psi_a/2)*(a-a(-1))^2/a_bar - (psi_db/2)*(d-d(-1))^2/d_bar ;

// Optimal conditions****************
   //Respect to h_P***10
   (1+ tau_l+ psi_hh*(h_P-h_P(-1))/h_P_bar)*p_h  = beta_P* ( (varphi_h/ (lambda_P *  h_P)) + (lambda_P(1)/ lambda_P )*((1- delta_h- tau_p*(1- tau_w))*p_h(1)-I_r * tau_w*(p_R(1)- delta_h)
+psi_hh* p_h(1)*(h_P(1)-h_P)/h_P_bar ));

   //Respect to h_R***11
   (1+ tau_l + psi_hh*(h_R-h_R(-1))/h_R_bar)* p_h  = beta_P * ( (lambda_P(1)/ lambda_P )*((1- delta_h- tau_p *(1- tau_w))* p_h(1)+(1- tau_w)*p_R(1)+ tau_w * delta_h
+ psi_hh * p_h(1)*(h_R(1)-h_R)/h_R_bar ));
 
   //Respect to d***12
   1 + psi_dh *(d-d(-1))/d_bar= beta_P * ( (lambda_P(1)/ lambda_P )*(1+(1- tau_d)*r(1)+psi_dh*(d(1)-d)/d_bar )) ; 
//*****1 = beta_P * ( (lambda_P(1)/ lambda_P )*(1+(1- tau_d)*r(1) )) ;
   //Respect to k***13
   p_k + psi_k *(k-k(-1))/k_bar = beta_P*  ( (lambda_P(1)/ lambda_P )*((1- delta_k)*p_k(1)+(1- tau_k)*r_k(1)+ tau_k*  delta_k + psi_k *(k(1)-k)/k_bar ));  
//*****p_k  = beta_P*  ( (lambda_P(1)/ lambda_P )*((1- delta_k)*p_k(1)+(1- tau_k)*r_k(1)+ tau_k*  delta_k  ));  
   //Respect to h_I***14
   ( p_h+ tau_l-  (lambda_m / lambda_I )*(1- rho_m)* theta* p_h(1)/(1+r_b(1))+ psi_hh*(h_I-h_I(-1))/h_I_bar)  = beta_I*  ( ( varphi_h/( lambda_I *  h_I)) 
+ (lambda_I(1)/ lambda_I )*((1- delta_h- tau_p * (1- tau_w))*p_h(1)-I_r * tau_w*(p_R(1)- delta_h)+psi_hh*p_h(1)*(h_I(1)-h_I)/h_I_bar ));  

   //Respect to Mortgage***15
   (1- (lambda_m / lambda_I)+ psi_m*(M-M(-1))/M_bar) = beta_I * ( (lambda_I(1)/ lambda_I )*(1+(1-I_m *tau_w)*r_b(1) - (lambda_m(1)/ lambda_I )* rho_m
+psi_m*(M(1)-M)/M_bar )) ; 

   //Respect to h_R ***16
   p_R = ( varphi_h/( lambda_R*  h_R(-1)));

   //Respect to labors***17,18,19
  varphi_l *(l_P )^iota= lambda_P * (1- tau_w)*w_P  ; 
  varphi_l *(l_I )^iota= lambda_I * (1- tau_w)*w_I   ;
  varphi_l *(l_R )^iota= lambda_R * (1- tau_wr)*w_R ;  


   //Respect to d bank***20
   1-(lambda_phi/lambda_B)- psi_db *(d-d(-1))/d_bar=   beta_B*  (lambda_B(1)/ lambda_B ) *(1+r(1)- rho_b*lambda_phi(1)/lambda_B(1)- psi_db *(d(1)-d)/d_bar)  ;

   //Respect to "a": asset bank***21
   1-(lambda_phi/lambda_B)* (phi*(1-rho_b)+rho_b)+ psi_a*(a-a(-1))/a_bar=  beta_B * (lambda_B(1)/ lambda_B )*(1+r_b(1)- rho_b*lambda_phi(1)/lambda_B(1)+ psi_a*(a(1)-a)/a_bar) ; 

   //Firm problem
    alpha_Y*Y_f/k(-1)=r_k  ;//22
   (1- alpha_Y)* iota_P* (Y_f /l_P)=w_P ;//23
   (1- alpha_Y)* iota_I* (Y_f /l_I)=w_I ;//24
   (1- alpha_Y)* iota_R* (Y_f /l_R)=w_R ;//25

// Financial Frictions******************************
//(los) = RHOS*(los(-1)) + (1-RHOS)*MS*exp(a_mh)*((q(+1))*(hs)/(rs(+1))-BORRGAIN*LOSSCON*a_bh*(Y_SS)) ;

   M =  rho_m* M(-1)+(1- rho_m)* theta * (p_h(1)* h_I/(1+r_b(1)-TB_I * Y_bar)) ;//26

   d =rho_b * (d(-1)-(a(-1)-TB_T_1(-1)* Y_bar))+(1-(1-phi)*(1-rho_b))*(a-TB_T(1)* Y_bar) ; //27 help_time_1 eyqtion 44 if rho_b=0=> d= phi(a-TB(1));

//Government*********************************
 C =c_P +c_I +c_R +c_B   ;//28

 T = tau_c* C + tau_w*(w_P* l_P +(p_R - delta_h)*( h_R(-1)+I_r * h_P(-1))- tau_p  * ( h_P(-1)+ h_R(-1)))+ tau_d *r* d(-1) 
 + tau_p * ( h_P(-1)+ h_R(-1))+ tau_l  *( h_P + h_R )+ tau_k*(r_k - delta_k)*k(-1) 
 + tau_w*(w_I* l_I -I_m* r_b*M(-1)+I_r*(p_R - delta_h)*  h_I(-1)- tau_p   *  h_I(-1))+ tau_p  *   h_I(-1)+ tau_l  *  h_I   
 + tau_wr*w_R*  l_R;   //29

   b_g +T =(1+r_b)*b_g(-1) - TB_g * Y_bar  + g + tr + (psi_g/2)* (b_g-b_g(-1))^2/b_g_bar   ;//30 for gov shock -TB should be added to the RHS
//+ GS
   tr_P = vartheta_P * Y_f - rho_g* b_g(-1);//31
   tr_I = vartheta_I * Y_f - rho_g* b_g(-1);//32
   tr_R = vartheta_R * Y_f - rho_g* b_g(-1);//33

   g=Expenditure_G  + TB_g * Y_bar; //34
   h=h_P+h_I+h_R;//35
   tr=tr_P+tr_I+tr_R;//36
// non-housing output*********************************
   Y_f = A * k(-1)^alpha_Y * ((l_P )^iota_P * (l_I )^iota_I * (l_R )^iota_R)^(1- alpha_Y);//37

// GDP *********************************
   Y=(1+tau_c)*C+p_R*h(-1)+i_k+i_h+g;//38

// capital and housing producer *********************************
   (1-psi_kp*(i_k/i_k(-1)-1)^2/2)*i_k=k-(1-delta_k)*k(-1); //39
   (1-psi_h/2*(i_h/i_h(-1)-1)^2)*i_h= h-(1-delta_h)* h(-1);//40
    p_k-psi_kp*p_k*(i_k/i_k(-1)-1)*(i_k/i_k(-1))-psi_kp*p_k*(i_k/i_k(-1)-1)^2/2+beta_P*((lambda_P(1)/lambda_P)*psi_kp*p_k(1)*(i_k(1)/i_k-1)*(i_k(1)/i_k)^2)=1;//41
    p_h-psi_h *p_h*(i_h/i_h(-1)-1)*(i_h/i_h(-1))-psi_h *p_h*(i_h/i_h(-1)-1)^2/2+beta_P*((lambda_P(1)/lambda_P)*psi_h *p_h(1)*(i_h(1)/i_h-1)*(i_h(1)/i_h)^2)=1;//42


//******* shock
 TB_I= rho_TB * TB_I(-1)+epsilon_TB_I; //43
 TB_g= rho_TB * TB_g(-1)+epsilon_TB_g; //44
//(g-Expenditure_G)/Expenditure_G= rho_GS *(g(-1)-Expenditure_G)/Expenditure_G + epsilon_GS ;//34
 TB_T=TB_I+TB_g; //45
GS= rho_GS * GS(-1)+epsilon_GS; //46
 TB_T_1=TB_T(1);//47

//******
data_Y = (Y)/Y_bar-1; //48
data_C = (C/C_bar-1) ; //49
data_Ik = (i_k/i_k_bar-1) ; //50
data_Ih = (i_h/i_h_bar-1) ; //51
data_a = (a/a_bar-1)  ; //52
data_M = (M/M_bar-1)  ; //53
data_b_g = (b_g/b_g_bar-1)  ; //54
data_p_h = (p_h/p_h_bar-1) ; //55
data_loss = TB_T ; //56
spread_rb_r = 4*1*((r_b)-(r)); //57
end;
// ***********************************




load just_for_check_0_Dyna.mat;
initval;
lambda_P=lambda_P_0;lambda_I=lambda_I_0;lambda_R=lambda_R_0;
lambda_B=lambda_B_0;lambda_m=lambda_m_0;lambda_phi=lambda_phi_0;
c_P=c_P_0; c_I=c_I_0; c_R=c_R_0; c_B=c_B_0; 
h_P=h_P_0; h_I=h_I_0; h_R=h_R_0;  p_R=p_R_0;
k=k_0; d=d_0; r=r_0; r_k=r_k_0;M=M_0; r_b=r_b_0;
a=a_0; 
w_P=w_P_0; w_I=w_I_0; w_R=w_R_0;
l_P=l_P_0; l_I=l_I_0; l_R=l_R_0;

C=C_0; T=T_0; b_g=b_g_0; tr_P=tr_P_0; tr_I=tr_I_0; tr_R=tr_R_0; g=g_0;
h=h_0;tr=tr_0;Y=Y_0;Y_f=Y_f_0;i_k=i_k_0;i_h=i_h_0; p_h=p_h_0;p_k=p_k_0;
//
epsilon_TB_I=0;TB_I=0; %epsilon_TB_g=0;epsilon_GS=0;TB_g=0;GS=0;

end;
// ***********************************
check;
shocks;
var epsilon_TB_I ; stderr 0.001;
%var epsilon_TB_g ; stderr 0.001;
%var epsilon_GS ; stderr 0.001;
end;


steady(nocheck) ;
check;

varobs data_C ; 

estimated_params ;
//%            START VALUES          &           PRIORS
    
stderr epsilon_TB_I  ,       0.0017  ,  0    ,  Inf  ,        inv_gamma_pdf,   0.0025  ,  0.025 ; 
    
psi_db               ,       0.2500  ,  0    ,  Inf  ,        gamma_pdf  ,   0.25     ,  0.125 ;
psi_dh               ,       0.2500  ,  0    ,  Inf  ,        gamma_pdf  ,   0.25     ,  0.125 ;
psi_k                ,       1.3050  ,  0    ,  Inf  ,        gamma_pdf  ,   1        ,  0.5 ;         
psi_m                ,       0.2500  ,  0    ,  Inf  ,        gamma_pdf  ,   0.25     ,  0.125 ;
psi_a                ,       0.500   ,  0    ,  Inf  ,        gamma_pdf  ,   0.25     ,  0.125 ; // sum of two parameters in iacoville
psi_h                ,       2.000   ,  0    ,  Inf  ,        gamma_pdf  ,   0.25     ,  0.125 ; 

rho_b                ,       0.24    ,  0    ,   1   ,        beta_pdf   ,   0.25    ,   0.10 ;      //0.4613
rho_m                ,       0.70    ,  0    ,   1   ,        beta_pdf   ,   0.25    ,   0.10 ;      //0.4613
rho_TB               ,       0.9788  ,  0    ,   1   ,        beta_pdf   ,   0.80    ,   0.10 ;
%rho_g                ,       0.003   ,  0   , 0.1   ,        beta_pdf   ,   0.001   ,   0.5 ;

end;

options_.subdraws = 100;

estimation(datafile=MYDATA,
mh_jscale=0.7, 
mode_compute=4, mode_check,
smoother,  
presample=20, prior_trunc=1e-12,
mh_replic=10000,  mh_nblocks=1, lik_init=2, order=1, bayesian_irf) 
data_C data_Y data_Ik data_Ih data_a data_M data_p_h;

shock_decomposition;
save H_4_estimation_findings_bayesian ;


